#ifndef ONI_H
#error Do not include this file directly, include Oni/Oni.h instead!
#endif

#ifndef BFW_WINDOWMANAGER_H
#define BFW_WINDOWMANAGER_H

typedef struct WMtWindow {
	struct WMtWindow *next_sibling;
	struct WMtWindow *prev_sibling;
	struct WMtWindow *parent;
	struct WMtWindow *owner;
	struct WMtWindow *child;
	void *window_class;
	uint32_t state;
	uint32_t style;
	short id;
	uint32_t window_array_index;
	short left;
	short top;
	short width;
	short height;
	// more
} WMtWindow;

typedef struct {
	WMtWindow *window;
	uint32_t event_id;
	uint32_t period;
	uint32_t next_expiry;
} WMtTimer;

typedef enum {
	WMcWM_NC_Create = 0x1,
	WMcWM_NC_Destroy = 0x2,
	WMcWM_NC_HitTest = 0x3,
	WMcWM_NC_Paint = 0x4,
	WMcWM_NC_MouseMove = 0x5,
	WMcWM_NC_LButtonDown = 0x6,
	WMcWM_NC_LButtonUp = 0x7,
	WMcWM_NC_LButtonDblClk = 0x8,
	WMcWM_NC_MButtonDown = 0x9,
	WMcWM_NC_MButtonUp = 0xa,
	WMcWM_NC_MButtonDblClk = 0xb,
	WMcWM_NC_RButtonDown = 0xc,
	WMcWM_NC_RButtonUp = 0xd,
	WMcWM_NC_RButtonDblClk = 0xe,
	WMcWM_NC_CalcClientSize = 0x11,
	WMcWM_Create = 0x12,
	WMcWM_Destroy = 0x13,
	WMcWM_Timer = 0x1b,
	WMcWM_MouseMove = 0x1e,
	// Mac Oni 1.2.1 inserts two messsages here for mouse wheel scrolling. We
	// don't have that luxury so ours is at the end.
	WMcWM_LButtonDown = 0x1f,
	WMcWM_LButtonUp = 0x20,
	WMcWM_LButtonDblClk = 0x21,
	WMcWM_MButtonDown = 0x22,
	WMcWM_MButtonUp = 0x23,
	WMcWM_MButtonDblClk = 0x24,
	WMcWM_RButtonDown = 0x25,
	WMcWM_RButtonUp = 0x26,
	WMcWM_RButtonDblClk = 0x27,
	WMcWM_Activate = 0x28,
	WMcWM_SetFocus = 0x29,
	WMcWM_KillFocus = 0x2a,
	WMcWM_Paint = 0x2b,
	WMcWM_ResolutionChanged = 0x34,
	WMcWM_FontInfoChanged = 0x35,
	WMcWM_Quit = 0x39, // WM_QUIT equivalent.
} WMtWM;

typedef enum {
	WMcWindowState_Visible = 0x1,
	WMcWindowState_Disabled = 0x2,
	WMcWindowState_Unknown = 0x4,
} WMtWindowState;

typedef enum {
	WMcHitTest_Client = 0x8000,
} WMtHitTest;

#endif
